"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const RealDate = global.Date;
function mockDate() {
    global.Date = new Proxy(RealDate, handler);
}
exports.mockDate = mockDate;
function unmockDate() {
    global.Date = RealDate;
}
exports.unmockDate = unmockDate;
let now = Date.now();
function advanceTimeBy(ms) {
    now += ms;
}
exports.advanceTimeBy = advanceTimeBy;
const handler = {
    construct(target, args) {
        if (args.length === 0) {
            return new Date(now);
        }
        else {
            return new target(...args);
        }
    },
    get(target, propKey) {
        if (propKey === 'now') {
            return () => now;
        }
        else {
            return target[propKey];
        }
    },
};
//# sourceMappingURL=date.js.map